# -*- coding: utf-8 -*-
"""
Created on Tue Jun 25 13:29:43 2019

@author: jr1214
"""

import numpy as np
import pandas as pd
import matplotlib.pyplot as plt
from scipy.cluster import hierarchy as hc
#from hcluster import pdist, linkage, dendrogram

RelAbundance_frame = pd.read_csv("BookClass.csv",header=0)

#WD R:\rsrch\jpjc1\phd\jr1214\Thesis\Chapter 1- feedstocks and inoculum\Chap1-PotAleMM

#FilterSelection

StorageTemp = RelAbundance_frame.iloc[[0]]
StorageDur = RelAbundance_frame.iloc[[1]]
Timepoint = RelAbundance_frame.iloc[[2]]


GenusData = RelAbundance_frame.loc[3:25]
GenusData = GenusData.set_index(["Class"])
#MM = GenusData     = GenusData.iloc[:,:18]
#StorageD0          = GenusData = GenusData.iloc[:,np.r_[19:21 , 33:36, 50:53]]
#StorageAll         = GenusData = GenusData.iloc[:,19:65]
#StorageD21         = GenusData = GenusData.iloc[:,np.r_[29:33 , 45:49, 61:65]]
#FTall              = GenusData = GenusData.iloc[:,np.r_[65:95]]


GenusData = GenusData.iloc[:,np.r_[65:95]]



LinkMethod = "weighted"
metric = 'correlation'

z = hc.linkage(GenusData.values.T, method=LinkMethod, metric=metric)
#z = hc.linkage(corr_condensed, method=LinkMethod, metric=metric)

plt.figure(num=None, figsize=(20, 4),  facecolor='w', edgecolor='k')
dendrogram = hc.dendrogram(z, labels=GenusData.columns,  color_threshold=0.04, leaf_font_size=10, leaf_rotation=90)

for key in dendrogram.keys():
    if key == 'ivl':
        DenOrder = dendrogram[key]

plt.savefig(LinkMethod + metric +'Dendrogram.png')


#GenusData = RelAbundance_frame.loc[3:]
#pivotdf = GenusData.pivot(columns ="Genus" )
GenusData = RelAbundance_frame.loc[3:22]
GenusData = GenusData.set_index(["Class"])
GenusData = GenusData[DenOrder]
GenusData = GenusData.transpose()


GenusData = GenusData.astype(float)
#plt.figure(figsize=(10,4), dpi = 140)
#plt.xlim(0,100)
GenusData.plot.bar(figsize=(20,6), stacked=True, legend = None, colormap="tab20")
plt.legend(loc='center left', labelspacing=-2.5,  bbox_to_anchor=(1.0, 0.5))
#plt.legend((p1[0], p2[0], p3[0], p4[0]), (header[0], header[1], header[2], header[3]), fontsize=12, ncol=4, framealpha=0, fancybox=True)




plt.savefig('AllOrderedRelAbundance.png')
plt.show()

#for key in dendrogram:
 #   print (key, dendrogram[ivl])
    
#print([key for key in dendrogram.keys()][2])
#
#for key in dendrogram.keys():
#    if key == 'ivl':
#        DenOrder = dendrogram[key]
#        
#print (DenOrder)
      



